package com.chaozhanggui.dao.system.util;

import java.math.BigDecimal;
import static java.math.BigDecimal.ROUND_DOWN;


//    如果第一个参数与第二个参数相等返回0。
//    如果第一个参数小于第二个参数返回 -1。
//    如果第一个参数大于第二个参数返回 1。
public class N {

    public static final int SCALE = 6;

    public static final boolean isZero(BigDecimal num) {
        return num == null || BigDecimal.ZERO.compareTo(num) == 0;
    }

    public static final boolean isNull(BigDecimal num) {
        return num == null;
    }


    public static final boolean eq(BigDecimal n1, BigDecimal n2) {
        return (!isNull(n1) && !isNull(n2) && n1.compareTo(n2) == 0);//n1==n2
    }

    public static final boolean gt(BigDecimal n1, BigDecimal n2) {
        return (!isNull(n1) && !isNull(n2) && n1.compareTo(n2) > 0);//n1>n2
    }

    public static final boolean egt(BigDecimal n1, BigDecimal n2) {
        return (!isNull(n1) && !isNull(n2) && n1.compareTo(n2) >= 0);
    }


    public static final BigDecimal mul(BigDecimal b1, BigDecimal b2) {
        if (isNull(b1) || isNull(b2))
            throw new IllegalArgumentException();

        return b1.multiply(b2).setScale(SCALE, ROUND_DOWN);
    }


    public static final BigDecimal div(BigDecimal b1, BigDecimal b2) {
        if (isNull(b1) || isZero(b2))
            throw new IllegalArgumentException();

        return b1.divide(b2, SCALE, ROUND_DOWN);
    }


}
